/* Sistemas Integrados TECNISA
   Compras e Suprimentos

Nome: 8130_SUPSTPO.sql

Descrio:
Calcula o custo da lista de preo inflacionada

Criao:
07/01/2005 Joo Fernando dos Reis Corra
*/

CREATE OR REPLACE PROCEDURE CUSTO_LISTAINFLAC
(
   P_CDFILCENTCMP IN LISTAINFLAC.CDFILCENTCMP%TYPE,
   P_NRLISTINFLAC IN LISTAINFLAC.NRLISTINFLAC%TYPE,
   P_CDOPERADOR   IN OPERADOR.CDOPERADOR%TYPE
)
IS
   V_DTREFLISTINF DATE;
   V_DTINILISTINF DATE;
   V_DTFINLISTINF DATE;

   V_DTFINCUSTOLP DATE;

   V_DTAUXREF     DATE;
BEGIN
   SELECT
      DTREFLISTINF, DTINILISTINF, DTFINLISTINF
   INTO
      V_DTREFLISTINF, V_DTINILISTINF, V_DTFINLISTINF
   FROM
      LISTAINFLAC
   WHERE
      CDFILCENTCMP = P_CDFILCENTCMP AND
      NRLISTINFLAC = P_NRLISTINFLAC;

   INSERT INTO LOGLISINFLAC
      (CDFILCENTLLI, NRLISTINFLLI, CDOPERADOR, DTGERLISINF)
   VALUES
      (P_CDFILCENTCMP, P_NRLISTINFLAC, P_CDOPERADOR, SYSDATE);

   FOR C_PERLISINFLAC IN
      (SELECT
          FILIAL.CDFILIAL,
          A.CDPRODUTO,
          PERLISINFLAC.VRPERLISTINF,
          CUSTOSUP.VRCUSPRLISTP,
          CUSTOSUP.VRCUSPRLISM1,
          CUSTOSUP.VRCUSPRLISM2,
          CUSTOSUP.DTCUSTOSUP,
          CUSTOSUP.DTFINCUSTSUP
       FROM
          CUSTOSUP,
          PRODUTO,
          (SELECT
              P.CDPRODUTO,
              MAX(PRODUTO.CDARVPROD) AS CDPRODNIVEL
           FROM
              PRODUTO,
              PRODUTO P,
              PERLISINFLAC
           WHERE
              PERLISINFLAC.CDFILCENTCMP = P_CDFILCENTCMP AND
              PERLISINFLAC.NRLISTINFLAC = P_NRLISTINFLAC AND
              PERLISINFLAC.CDPRODUTO = PRODUTO.CDPRODUTO AND
              P.CDARVPROD LIKE PRODUTO.CDARVPROD || '%' AND
              P.CDPRODESTO IS NOT NULL
          GROUP BY
             P.CDPRODUTO) A,
          FILIAL,
          PERLISINFLAC
       WHERE
          PERLISINFLAC.CDFILCENTCMP = P_CDFILCENTCMP AND
          PERLISINFLAC.NRLISTINFLAC = P_NRLISTINFLAC AND
          NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = PERLISINFLAC.CDFILCENTCMP AND
          PERLISINFLAC.CDPRODUTO = PRODUTO.CDPRODUTO AND
          PRODUTO.CDARVPROD = A.CDPRODNIVEL AND
          (NVL(CUSTOSUP.VRCUSPRLISTP, 0) + NVL(CUSTOSUP.VRCUSPRLISM1, 0) + NVL(CUSTOSUP.VRCUSPRLISM2, 0)) > 0 AND
          CUSTOSUP.IDCUSLISTINF <> 'S' AND
          CUSTOSUP.CDFILIAL = FILIAL.CDFILIAL AND
          CUSTOSUP.CDPRODUTO = A.CDPRODUTO AND
          CUSTOSUP.DTCUSTOSUP = (SELECT
                                    MAX(C.DTCUSTOSUP)
                                 FROM
                                    CUSTOSUP C
                                 WHERE
                                    C.CDFILIAL = CUSTOSUP.CDFILIAL AND
                                    C.CDPRODUTO = CUSTOSUP.CDPRODUTO AND
                                    C.DTCUSTOSUP <= V_DTREFLISTINF AND
                                   (NVL(C.VRCUSPRLISTP, 0) + NVL(C.VRCUSPRLISM1, 0) + NVL(C.VRCUSPRLISM2, 0)) > 0 AND
                                    C.IDCUSLISTINF <> 'S'))
   LOOP
      SELECT       /*PARA NAO INCLUIR CUSTO DE LISTA INFLACIONADA SE JA HOVER CUSTO DE LISTA DE PRECO*/
         MAX(C.DTFINCUSTSUP) INTO V_DTFINCUSTOLP
      FROM
         CUSTOSUP C
      WHERE
         C.CDFILIAL = C_PERLISINFLAC.CDFILIAL AND
         C.CDPRODUTO = C_PERLISINFLAC.CDPRODUTO AND
         C.DTCUSTOSUP <= V_DTFINLISTINF AND
         C.DTFINCUSTSUP >= V_DTINILISTINF AND
         (NVL(C.VRCUSPRLISTP, 0) + NVL(C.VRCUSPRLISM1, 0) + NVL(C.VRCUSPRLISM2, 0)) > 0 AND
         C.IDCUSLISTINF <> 'S';

      V_DTAUXREF := V_DTINILISTINF; /*A LISTA INFLACIONADA NO PODE SOBREPOR UMA LISTA DE PREO, NESTE CASO ELA  ADIANTADA.*/
      IF V_DTFINCUSTOLP >= V_DTINILISTINF THEN
        V_DTAUXREF := V_DTFINCUSTOLP + 1;
      END IF;
      IF V_DTAUXREF <= V_DTFINLISTINF THEN
         DELETE FROM CUSTOSUP
         WHERE
            CDFILIAL = C_PERLISINFLAC.CDFILIAL AND
            CDPRODUTO = C_PERLISINFLAC.CDPRODUTO AND
            DTCUSTOSUP = V_DTAUXREF;
         INSERT INTO CUSTOSUP (CDFILIAL,     CDPRODUTO,    DTCUSTOSUP,   VRCUSPRLISTP,
                               VRCUSPRLISM1, VRCUSPRLISM2, DTFINCUSTSUP, CDFILCENTCMP,
                               NRLISTINFLAC, VRPERLISINFL, CDFILIALORIG, CDPRODORIG,
                               DTCUSTSUPORI, IDCUSLISTINF)
         VALUES (C_PERLISINFLAC.CDFILIAL,
                 C_PERLISINFLAC.CDPRODUTO,
                 V_DTAUXREF,
                 C_PERLISINFLAC.VRCUSPRLISTP*(1 + (C_PERLISINFLAC.VRPERLISTINF / 100)),
                 C_PERLISINFLAC.VRCUSPRLISM1*(1 + (C_PERLISINFLAC.VRPERLISTINF / 100)),
                 C_PERLISINFLAC.VRCUSPRLISM2*(1 + (C_PERLISINFLAC.VRPERLISTINF / 100)),
                 V_DTFINLISTINF,
                 P_CDFILCENTCMP,
                 P_NRLISTINFLAC,
                 C_PERLISINFLAC.VRPERLISTINF,
                 C_PERLISINFLAC.CDFILIAL,
                 C_PERLISINFLAC.CDPRODUTO,
                 C_PERLISINFLAC.DTCUSTOSUP,
                 'S');
         COMMIT;
      END IF;
   END LOOP;
END;
/
