/*para construir essa tela, usei:
Cmp08000SolicitacaoDeComprasPorAgrupamento.php
Cmp08000_SolicitacaoDeComprasPorAgrpamento_Controller.js
cmp08000_solicitacao_de_compras_por_agrupamento.json
controllers.xml
routes.json do cmp/relatorios*/


function Cmp08000_SolicitacaoDeComprasPorAgrupamento_Controller(validateEngine, General, Utilities, ScreenService, templateManager, localStorageEngine, restEngine, ZhFilterPreferences, ZhUtil, MessageService) {

    var self = this;            //coloca self para não dar problema no this. quando é usado dentro de uma função para representar outra função do mesmo arquivo.
    var listaUnidades = '';

    this.onEnterFilterWidget = function(widget) {
        let filterRow = {}; 
        
        filterRow.REPORT_NAME = "CMP08000";
        
        filterRow.INTERVAL_DT = {};
        filterRow.INTERVAL_DT.start = moment().format("L");
        filterRow.INTERVAL_DT.end = moment().format("L");
        filterRow.INTERVAL_DT.formattedStart = moment().format('L');                                                                                                                                                                                                                                        
        filterRow.INTERVAL_DT.formattedEnd = moment().format('L');
        
        self.setHeaderReport(widget);
        
        Utilities.startFilter(widget, filterRow);
    };
    
    this.clearFilterSolicitacaoCompraPorAgrupamento = function (args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.prepareFilterSolicitacaoCompraPorAgrupamento = function (args) {
        const row = args.e.preference.FILTER_ROW;
        const widget = args.owner;
    
        widget.dataSourceFilter = self.createDataSourceFilter(row);
        
        self.setStripeSolicitacaoCompraPorFornecedor(row);
        
        //widget._filterInfo = setFilterInfo(row);
        
        widget.reload();
        widget.activate();
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        
        if (prodInicial && prodFinal) {
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    };
    
    this.setProductIntervalFilterOnFilterPopup = function(args, field) {
        const  filterPopupCurrentRow = args.row;
        
        if (!(self.validaProduto(filterPopupCurrentRow.CDARVPRODINI, filterPopupCurrentRow.CDARVPRODFIN))) {
            if (field.name == 'NMPRODINI') {
                filterPopupCurrentRow.PRODINI = '';
                filterPopupCurrentRow.CDPRODINI = '';
                filterPopupCurrentRow.CDARVPRODINI = '';
                filterPopupCurrentRow.NMPRODINI = '';
            } else {
                filterPopupCurrentRow.PRODFIN = '';
                filterPopupCurrentRow.CDPRODFIN = '';
                filterPopupCurrentRow.CDARVPRODFIN = '';
                filterPopupCurrentRow.NMPRODFIN = '';
            }
        }
            
    };
	
    this.createDataSourceFilter = function(row) {
        return [
        	{
        		"name": "P_TDTINI",
		        "operator": "=",
		        "value": row.INTERVAL_DT.formattedStart
        	},
        	{
        		"name": "P_TDTFIN",
		        "operator": "=",
		        "value": row.INTERVAL_DT.formattedEnd
        	},
        	{
        		"name": "P_DTINI",
		        "operator": "=",
		        "value": row.INTERVAL_DT.formattedStart
        	},
        	{
        		"name": "P_DTFIN",
		        "operator": "=",
		        "value": row.INTERVAL_DT.formattedEnd
        	},
        	{
        		"name": "P_PRODINI",
		        "operator": "=",
		        "value": row.CDARVPRODINI	
        	},
        	{
        		"name": "P_PRODFIN",
		        "operator": "=",
		        "value": self.concatProdutoFinal(row.CDARVPRODFIN)
        	}
        ];
    };
    
    this.setStripeSolicitacaoCompraPorFornecedor = function(row) {
        const currentRowStripe = templateManager.container.getWidget('stripe').currentRow;
        
        currentRowStripe.DTENTREGA = ScreenService.i18n("De ") + row.INTERVAL_DT.start  + ScreenService.i18n(" até ") + row.INTERVAL_DT.end;
        currentRowStripe.CDPRODINI = row.NMPRODFIN;
        currentRowStripe.CDPRODFIN = row.NMPRODFIN;
    };
    
    this.setHeaderReport = function(widget) {
        widget.beforeGenerateReport = function(beforeReportData) {
            const row = templateManager.container.getWidget('cmp08000').appliedFilter.FILTER_ROW;
            
            beforeReportData.metadata.filter = [
                { "label": ScreenService.i18n("Agrupamento"), "value" : self.concatArrayForParams(row.NMGRUPFILI, ScreenService.i18n('Todos')) },
                { "label": ScreenService.i18n("Região"), "value" : self.concatArrayForParams(row.NMREGIAO, ScreenService.i18n('Todas')) },
                { "label": ScreenService.i18n("Produto Inicial"), "value" : row.NMPRODINI },
                { "label": ScreenService.i18n("Produto Final"), "value" : row.NMPRODFIN },
                { "label": ScreenService.i18n("Entrega"), "value" : row.INTERVAL_DT.formattedStart  + ScreenService.i18n(" até ") + row.INTERVAL_DT.formattedEnd  }   
            ];
        };
    };
    
    this.concatArrayForParams =  function(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join(', ') : value;
        }
    
        return defaultValue;
    };
    
    this.concatProdutoFinal = function(value) {
        return value.padEnd(20,'Z');
    };
    
    this.validaData = function(dtInicial, dtFinal) {            //função para comparar as datas inicial e final e mostrar erro se a inicial for menor que a final.
        const dataInicial = dtInicial ? moment(dtInicial, 'DD/MM/YYYY')._d : null;        //se existir data inicial, ele manda seu valor para a variável  "dataInicial". Se não, manda null para a mesma.
        const dataFinal = dtFinal ? moment(dtFinal, 'DD/MM/YYYY')._d : null;              //se existir data final, ele manda seu valor para a variável  "dataFinal". Se não, manda null para a mesma.

        if (dataFinal < dataInicial) {              //se data inicial maior que data final,
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;                           //retorna falso, ou seja, não permite que a função que chama essa função dê continuidade.
        }
        
        return true;                                //se estiver tudo certinho, ele retorna verdadeiro e a função segue normalmente.
    };
    
    this.changeRequired = function(field) {
        const fieldProdIni = field.widget.getField('NMPRODINI');
        const fieldProdFin = field.widget.getField('NMPRODFIN');
        
        
        if (fieldProdIni.value() || fieldProdFin.value()){
            fieldProdIni.validations = { "required" : true };
            fieldProdFin.validations = { "required" : true };
        } else {
            fieldProdIni.validations = {};
            fieldProdFin.validations = {};
        }
    };

    this.validaProdutoRelatorio = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
    };

    this.criaRelatorio = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        if (!widget.getField('NMPRODINI').value() && !widget.getField('NMPRODFIN').value()) {
            currentRowWidget.PRODUTO = 'T';
        } else {
            currentRowWidget.PRODUTO = 'X';
        }
        
        var reportName  = currentRowWidget.CD_REPORT_NAME;      //cria uma variável contendo a linha atual de CD_REPORT_NAME, que é o nome do relatório.
        
        if (widget.isValid() && this.validaProdutoRelatorio(currentRowWidget.PRODINI, currentRowWidget.PRODFIN)) {    //se a widget está válida (ou seja, se todos os campos obrigatórios estão preenchidos) e as datas também estão válidas,
            General.openReportPopup(widget, self.abreRelatorio, [widget, currentRowWidget, reportName]);   //abre o popup do general que pergunta o tipo de relatório que será gerado (pdf, etc.). Os parâmetros passados podem ser vistos lá no arquivo General.js.
        }
        
    };
    
    this.concatenaAgrupamento = function(row) {
        if (row.L_GRUPFILI === "" || Util.isEmptyObject(row.L_GRUPFILI)) {           //se o field estiver vazio ou for um array vazio, retorna a opção "T",
            row.GRUPFILI = 'T';                         // que representa todos os campos. Esse valor vai para a lista e é interpretado para o relatório.
            return row.GRUPFILI;
        } else {
            row.GRUPFILI = row.L_GRUPFILI.join('_');      //concatena cada item marcado com um underline separando. Faz isso para mandar para a lista que será mandada para o relatório.
            return row.GRUPFILI;                        //retorna os itens concatenados como se fossem uma coisa só.
        }
    }; 
    
    this.concatenaRegiao = function(row) {
        if (row.L_REGIAO === "" || Util.isEmptyObject(row.L_REGIAO)) {              //se o field estiver vazio ou for um array vazio, retorna a opção "T",
            row.REGIAO = 'T';                         // que representa todos os campos. Esse valor vai para a lista e é interpretado para o relatório.
            return row.REGIAO;
        } else {
            row.REGIAO = row.L_REGIAO.join('_');      //concatena cada item marcado com um underline separando. Faz isso para mandar para a lista que será mandada para o relatório.
            return row.REGIAO;                        //retorna os itens concatenados como se fossem uma coisa só.
        }
    };
    
    this.abreRelatorio = function(widget, currentRow, reportName) {
        currentRow.REGION    = self.concatenaRegiao(currentRow);             //chama a função concatenaRegiao (que retorna os campos selecionados concatenados).
        currentRow.OPERADOR  = self.concatenaAgrupamento(currentRow);           //chama a função concatenaOperador (que retorna os campos selecionados concatenados).
        currentRow.DATAINIC  = currentRow.INTERVAL_DT.start;
        currentRow.DATAFINA  = currentRow.INTERVAL_DT.end;
        currentRow.DTINI     = currentRow.INTERVAL_DT.start;
        currentRow.DTFIM     = currentRow.INTERVAL_DT.end;
        currentRow.DTINICIAL = currentRow.INTERVAL_DT.start;
        currentRow.DTFINAL   = currentRow.INTERVAL_DT.end;

        if(currentRow.PRODFIN) {
            currentRow.PRODFIN = currentRow.PRODFIN.padEnd(20,'Z');
            currentRow.PRODINI = currentRow.PRODINI;
        } else {
            
            currentRow.PRODINI = "";
            currentRow.PRODFIN = "";
        }
   	    General.openReport('cmp_solicitacao_relatorios#/cmp08000_relatorio', reportName, currentRow);   //chama a função openReport (procurá-la no General.js)
    };
    
    this.setIniData = function(widget) {
        widget.currentRow.INTERVAL_DT = { 
            'formattedStart': moment().format('L'), 
            'formattedEnd': moment().format('L'), 
            'start': moment().format('L'),
            'end': moment().format('L') 
        };
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp08000_SolicitacaoDeComprasPorAgrupamento_Controller', Cmp08000_SolicitacaoDeComprasPorAgrupamento_Controller);
});